#!/usr/local/bin/jperl5
use Extract;

&main();
exit(0);

sub main () {
   
    # setting
    my $obj = Extract->new->verbose->comb(1)->min_frq(0)->window(100000)->rate(0.01);
     $obj = &get_noun_frq($obj,@ARGV);	
    
    # start
    $obj->extract(@ARGV)->output(@ARGV);
;# ========================================================================
;# get_noun_frq -- Get noun frequency from input files.
;#                 The values of the hash are frequency of the noun.
;#
;# usage: $obj = $obj->get_noun_frq(@FILES);
;#        $obj = $obj->get_noun_frq($FILENAME);
;#option -s:ʸˤ -p:ͭ̾ˤ 
;# ========================================================================

    sub get_noun_frq ($;@) {
	my $this = shift;
	my @files = @_;             # input files
	my $line_no = 0;
	my %frq =();
	my($data); 
	my $fuku;
	my $teki;
	
	if( $files[0] =~ /^\-/){
	    open(IN, "$files[1]") || die "$files[1] : $!";
	}
	else{
	    open(IN, "$files[0]") || die "$files[0] : $!";
	}
	while (my $morph = <IN>){
	    $line_no++;
	    chomp $morph;
	    my @meisi = split(/\s+/,$morph);
	    if($fuku == 1){
		if($meisi[3] =~ /̾\-/ || $meisi[3] =~ /̾\-³/ || $meisi[3] =~ /̾\-\-/ || $meisi[3] =~ /̾\-\-³/ || $meisi[3] =~ /̤θ/ && $meisi[0] =~ /..+/ || $meisi[3] =~ /\-ե٥å/ && $meisi[0] =~ /..+/ || $meisi[3] =~ /^̾\-ͭ̾/ && $files[0] =~ /\-(p|sp|ps)/ ){
		    $teki =0;
		    $data .= " $meisi[0]";    #Ƕ
		}
		elsif($meisi[3] =~ /^ư/){
		    $data = "";
		    $fuku =0;
		    $teki =0;
		}
		elsif($meisi[3] =~ /^̾/ && $meisi[3] =~ // && $meisi[3] =~ /촴$/){
		    $teki =1;
		    $data .= " $meisi[0]";
		}
		elsif($meisi[0] =~ s// /){
		}
		else{
		    $data =~ s/\s+ʤ$//;
		    $data =~ s/\s+$//;
		    $data =~ s/^\s//;
		    $data =~ s/\s+[ⷿ]$//;
		    $data =~ s/\s$//;
		    if($files[0] =~ /\-(s|sp|ps)/ && @files > 1 && $teki == 0 || $data =~ /..+/ && $teki ==0){
			$frq{$data}++;
			$fuku = 0;
			$teki =0;
			$data = "";
		    }
		    else{
			$fuku =0;
			$teki =0;
			$data = "";
		    }
		}
	    }
	    else{
		if($meisi[3] =~ /̾\-/ || $meisi[3] =~ /̾\-³/ || $meisi[3] =~ /Ƭ\-̾³/ || $meisi[3] =~ /̤θ/ && $meisi[0] =~ /..+/ ||$meisi[3] =~ /\-ե٥å/ && $meisi[0] =~ /..+/ || $meisi[3] =~ /^̾\-ͭ̾/ && $files[0] =~ /\-(p|sp|ps)/ ){
		    $fuku =1;
		    $data .= "$meisi[0]";
		}
		elsif($meisi[3] =~ /̾\-ư촴/ || $meisi[3] =~ /̾\-ʥƻ촴/){
		    $fuku =1;
		    $teki =1;
		    $data .= "$meisi[0]";
		}
		else{
		}
	    }
	}
	
	$this->{'noun_frq'} = \%frq;
	
	print STDERR "done.\n"         if $this->{'env'}{'verbose'};
	print STDERR
	    scalar keys %{$this->{'noun_frq'}}, 
	    " nouns are candidates.\n" if $this->{'env'}{'verbose'};
	
	$this;
    }

}
















